<app-loader *ngIf="isLoad"></app-loader>

<div fxLayout="row" class="mb-16">
	<div>
		<button mat-flat-button color="accent" (click)="sendToEpgu()">
			Отправить на ЕПГУ
		</button>

		<div *ngIf="upguInfo">
			<div>
				Дата последней отправки: {{upguInfo.created | date: 'dd.MM.yyyy HH:mm, (zzzz)' }}
			</div>
			<div>
				Статус: {{upguInfo.name_status}}
			</div>

		</div>
	</div>

	<div fxFlex="">

	</div>
	<div>
		<button mat-flat-button color="primary" (click)="updateApplication()">
			Загрузить заявления
		</button>
	</div>

</div>

<div class="art-card"
	[@animate]="{value:'*',params:{delay:'300ms',y:'25px'}}">

	<table mat-table [dataSource]="data">

		<ng-container matColumnDef="id">
			<th mat-header-cell *matHeaderCellDef > ID </th>
			<td mat-cell *matCellDef="let row"> {{ row.id }}</td>
		</ng-container>

		<ng-container matColumnDef="fio">
			<th mat-header-cell *matHeaderCellDef > ФИО</th>
			<td mat-cell *matCellDef="let row"> {{row.surname}} {{row.name}} {{row.patronymic}}</td>
		</ng-container>

		<ng-container matColumnDef="uidEpgu">
			<th mat-header-cell *matHeaderCellDef > UID ЕПГУ</th>
			<td mat-cell *matCellDef="let row"> {{row.uid_epgu}} </td>
		</ng-container>

		<ng-container matColumnDef="admissionVolume">
			<th mat-header-cell *matHeaderCellDef > Всего мест</th>
			<td mat-cell *matCellDef="let row"> {{row.admission_volume}} </td>
		</ng-container>
		<ng-container matColumnDef="сommonRating">
			<th mat-header-cell *matHeaderCellDef > Рейтинг при подаче</th>
			<td mat-cell *matCellDef="let row"> {{row.common_rating}} </td>
		</ng-container>
		<ng-container matColumnDef="сommonRatingEdit">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field class="s-input">
						<input matInput [(ngModel)]="editData.common_rating" appInteger required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="agreedRating">
			<th mat-header-cell *matHeaderCellDef > Рейтинг c согласием</th>
			<td mat-cell *matCellDef="let row"> {{row.agreed_rating}} </td>
		</ng-container>
		<ng-container matColumnDef="agreedRatingEdit">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field class="s-input">
						<input matInput [(ngModel)]="editData.agreed_rating" appInteger required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="firstRating">
			<th mat-header-cell *matHeaderCellDef > Рейтинг реккоменд. к зач.</th>
			<td mat-cell *matCellDef="let row"> {{row.first_rating}} </td>
		</ng-container>
		<ng-container matColumnDef="firstRatingEdit">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field class="s-input">
						<input matInput [(ngModel)]="editData.first_rating" appInteger required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="сhangeRating">
			<th mat-header-cell *matHeaderCellDef > Позиция в рейтинге</th>
			<td mat-cell *matCellDef="let row">
				<span *ngIf="row.change_rating > 0">+</span>
				<span *ngIf="row.change_rating < 0">-</span>
				{{row.change_rating | replace : '-'}}
			</td>
		</ng-container>
		<ng-container matColumnDef="сhangeRatingEdit">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field class="s-input">
						<span matPrefix *ngIf="editData.change_rating > 0">+</span>
						<input matInput [(ngModel)]="editData.change_rating"
							appInteger
							[negative]="true"
							[positive]="true"
							required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="countApplication">
			<th mat-header-cell *matHeaderCellDef > Всего заявлений</th>
			<td mat-cell *matCellDef="let row"> {{row.count_application}} </td>
		</ng-container>
		<ng-container matColumnDef="countApplicationEdit">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field class="s-input">
						<input matInput [(ngModel)]="editData.count_application" appInteger required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="countAgreed">
			<th mat-header-cell *matHeaderCellDef > Всего согласий</th>
			<td mat-cell *matCellDef="let row"> {{row.count_agreed}} </td>
		</ng-container>
		<ng-container matColumnDef="countAgreedEdit">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field class="s-input">
						<input matInput [(ngModel)]="editData.count_agreed" appInteger required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="countFirstStep">
			<th mat-header-cell *matHeaderCellDef > Мест на 1й этап приема</th>
			<td mat-cell *matCellDef="let row"> {{row.count_first_step}} </td>
		</ng-container>
		<ng-container matColumnDef="countFirstStepEdit">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field class="s-input">
						<input matInput [(ngModel)]="editData.count_first_step" appInteger required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="countSecondStep">
			<th mat-header-cell *matHeaderCellDef > Мест на 2й этап приема</th>
			<td mat-cell *matCellDef="let row"> {{row.count_second_step}} </td>
		</ng-container>
		<ng-container matColumnDef="countSecondStepEdit">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field class="s-input">
						<input matInput [(ngModel)]="editData.count_second_step"
							appInteger required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>


		<ng-container matColumnDef="changed">
			<th mat-header-cell *matHeaderCellDef >Дата обновления</th>
			<td mat-cell *matCellDef="let row"> {{ row.changed | date: 'dd.MM.yyyy HH:mm' }}</td>
		</ng-container>

		<ng-container matColumnDef="action">
			<th mat-header-cell *matHeaderCellDef ></th>
			<td mat-cell *matCellDef="let row; let index = index;">
				<div *ngIf="!isEditData">
					<button mat-icon-button (click)="edit(row, index)">
						<mat-icon svgIcon="pencil"></mat-icon>
					</button>
				</div>
			</td>
		</ng-container>
		<ng-container matColumnDef="actionEdit">
			<td mat-cell *matCellDef="let row; let index = index;">
				<div *ngIf="editData.id === row.id" fxLayout="row">
					<button mat-icon-button (click)="save(row, index)">
						<mat-icon svgIcon="content-save"></mat-icon>
					</button>
					<button mat-icon-button (click)="cancel()">
						<mat-icon svgIcon="cancel"></mat-icon>
					</button>
				</div>
			</td>
		</ng-container>


		<ng-container matColumnDef="noRecord">
			<td mat-footer-cell *matFooterCellDef  [colSpan]="displayedColumns.length" ><i>Данные не найдены</i> </td>
		</ng-container>

		<tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: false"></tr>

		<tr mat-row *matRowDef="let row; columns: displayedColumns; when: !isEditRow"> </tr>
		<tr mat-row *matRowDef="let row; columns: editColumns; when: isEditRow" > </tr>
		<tr mat-row *matFooterRowDef="['noRecord']" [hidden]="data.length" ></tr>

	</table>
	<mat-paginator  [length]="total"
		[pageIndex]="params.page - 1"
		[pageSize]="params.limit"
		(page)="pagination.next($event)"
		[pageSizeOptions]="pageSizeOptions"
		showFirstLastButtons>
	</mat-paginator>
</div>
